;------------------------------------------------------------------------
; LED Candle 
; MCU	PIC12F683 (MICROCHIP)
; CLOCK	8MHZ
;
; Ver 1.00 	2010.DEC.12@LEDdqH̑fiZp]_Ёj
;
; YS Design Studio 2000-2010.
; URL http://www5b.biglobe.ne.jp/~YASUSI
;------------------------------------------------------------------------
; PIN Assign
; (8) GND
; (7) GPIO-0 LED1		<out>
; (6) GPIO-1 LED2		<out>
; (5) GPIO-2 PWM PULSE OUT	<out>
; (4) GPIO-3 SWITCH		<in> 
; (3) GPIO-4 ANI		<in>
; (2) GPIO-5 FREQ 		<in> 
; (1) VDD
;---------------------------------------------------------------------------

	list	p=12f683
	#include  <p12f683.inc>

	__CONFIG	_CP_OFF & _CPD_OFF & _WDT_OFF & _BOD_OFF & _PWRTE_OFF & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF

;------------------------------------------------------------
; Defain
;------------------------------------------------------------
WAIT1		EQU	0X20	; EFCgp
WAIT2		EQU	0X21	; EFCgp

MODE		EQU	0X22	; _ԃ[h
LOOP1		EQU	0X23 	;
ON_TIME1	EQU	0X24	; _ԃ[v
ON_TIME2	EQU	0X25	; _ԃ[v

TMR1_H		EQU	0x26	; COUNT VALUE (H)
TMR1_L		EQU	0x27	; COUNT VALUE (L)
A_SAVE		EQU	0X28	; AhXޔp

; 
RAND_VAL_H	EQU	0x29	; p 
RAND_VAL_L	EQU	0x2A	; p 
RAND_TMP_H	EQU	0x2B	; p@
RAND_TMP_L	EQU	0x2C	; p@
RAND_WORK	EQU	0X2D

;------------------------------------------------------------
; Power On vector
;------------------------------------------------------------
	ORG	0x00
       	goto	MAIN

;===================================================================
;                               MAIN
;===================================================================
;----------------------------
; Initialize PIC Microchip
;----------------------------
MAIN	
	movlw	b'00000111'
	movwf	CMCON0 		; CMCON = CM0/CM1/CM2 ON (COMPARATOR OFF)
	
	bsf	STATUS,RP0	;

	movlw	B'00111000'	; {HSB} xx111000 [LSB} 0=OUT / 1=IN
	movwf	TRISIO		; Port I/O Set

	movlw	B'01110000'	; INT OSC 8Mhz 
	movwf	OSCCON		;

	movlw	B'00001000'	; 
	movwf	WPU

	movlw	B'00001000'	; PORT CHANGE INT GP3 
	movwf	IOC

	movlw	B'01101000'	; FOSC/32 AD-PIN GPIO4 = ANS3 
	movwf	ANSEL

	bcf	STATUS,RP0	;

	movlw	B'10001000'	; Enable interrupt
	movwf	INTCON		; and clear flag

	movlw	B'00001100'	; Channel 03 (AN3)   ADFM(BIT7=0)= High-SIDE
	movwf	ADCON0

	clrf	GPIO		; Clear GPIO Port

;----------------------------
; Set PWM
;----------------------------
; SET FREQUENCY
	bsf	STATUS,RP0	; SET BANK1
	movlw	0xFA		; CYCLE 500uS (2Khz)
	movwf	PR2
	bcf	STATUS,RP0	; SET BANK0

; SET DUTY
	movlw	0x60
	movwf	CCPR1L		; SET Duty 0x60

	movlw	0x0C		; SET PWM
	movwf	CCP1CON

	movlw	B'00000101'	; TIMER2 Prescale = 1:4
	movwf	T2CON		; TIMER2 START

;----------------------------
; TMR1 INIT
;----------------------------
	clrf	T1CON

	movlw	B'00000111'	; TIMER2 Prescale = 1:1
	movwf	T1CON		; TIMER2 START

;-----------------------------------------------------
; ݒ 
;-----------------------------------------------------
	movlw	0X00
	movwf	RAND_VAL_H	; l̐ݒ@
	movlw	0X05
	movwf	RAND_VAL_L	; l̐ݒ@

	clrf	MODE
	bsf	MODE,0		;SET STARTUP MODE
	clrf	TMR1_L

;------------------------------------------------------
; MAIN LOOP
; _Ǝgv
; GATE Time = 630ms
;------------------------------------------------------
	movlw	0x0D
	movwf	ON_TIME2

MAIN_LOOP1
	movlw	0xFF
	movwf	ON_TIME1

MAIN_LOOP2
	movlw	D'60'	 	; 630ms
	movwf	LOOP1

	clrf	TMR1H		; FREQ COUNTER CLEAR
	clrf	TMR1L		; COUNTER START

LOOP_1
				; LED1
	call	SOUND_MONITOR	; AD
	call	BRIGHT_CONTROL	
	bcf	GPIO,0
	bsf	GPIO,1
	call	WAIT5MS
				; LED2
	call	SOUND_MONITOR	; AD
	call	BRIGHT_CONTROL	
	bsf	GPIO,0
	bcf	GPIO,1
	call	WAIT5MS

	decfsz	LOOP1,F		
	goto	LOOP_1

	movfw	TMR1L		; COUNT GET(L) COUNTER STOP
	movwf	TMR1_L

	call	FREQ_MONITOR	; g@

	decfsz	ON_TIME1,F
	goto	MAIN_LOOP2

	decfsz	ON_TIME2,F
	goto	MAIN_LOOP1

	call	FLASH_MODE7	; POWER OFF

	goto	MAIN_LOOP1

;=============================================================================
;                                  MAIN END
;                             SUB ROUTINE START
;=============================================================================

;==========================================================
; g 
;==========================================================
FREQ_MONITOR

	clrf	MODE		; MODE CLEAR

;-----------------------------------------------
; ΏۊO̎gB GateTime = 630ms / 200 = 317Hz
;-----------------------------------------------
; IF TMR1_L > 0xC8(200) THEN RETURN
	movlw	0xC8	
	subwf	TMR1_L,W
	btfss	STATUS,C
	goto	MODE7

	return

;-----------------------------------------------
; B GateTime = 630ms / 48 = 76Hz
;-----------------------------------------------
MODE7
; IF TMR1_L > 0x30(48) THEN POWER_OFF
	movlw	0x30	
	subwf	TMR1_L,W
	btfss	STATUS,C
	goto	MODE1

	bsf	MODE,7		; POWER OFF
	return
	
;-----------------------------------------------
; h炮B   GateTime = 630ms / 32 = 50Hz
;-----------------------------------------------
MODE1
; IF TMR1_L < 0x20(32) THEN MODE2
	movlw	0x20	
	subwf	TMR1_L,W
	btfss	STATUS,C
	goto	MODE2

	bsf	MODE,1
	return

;-----------------------------------------------
; h炮B GateTime = 630ms / 10 = 16Hz
;-----------------------------------------------
MODE2
; IF TMR1_L < 0x0A(10) THEN SET_CYCLE
	movlw	0x0A
	subwf	TMR1_L,W
	btfss	STATUS,C
	return

	bsf	MODE,2
	return

;==========================================================
; ω@ucc@P/QOu
;==========================================================
SOUND_MONITOR

;-----------------------------------------------
; `cϊ 
;-----------------------------------------------

	movlw	B'00000001'	; TIMER2 Prescale = 1:8
	movwf	T2CON		; TIMER2 STOP

	bsf	ADCON0,ADON	; ADC_ON

	call	WAIT20US	; W20US
	call	WAIT20US	; W20US

	bsf	ADCON0,GO	; ADC GO

	btfsc	ADCON0,GO
	goto	$-1

	movlw	B'00000101'	; TIMER2 Prescale = 1:8
	movwf	T2CON		; TIMER2 START

;-----------------------------------------------
; `c̓͂ 0XC0 ȏo
;-----------------------------------------------
; IF ADRESH > 0xC0 THEN NEXT1
	movlw	0xC8
	subwf	ADRESH,W
	btfss	STATUS,C
	goto	MODE3

	bsf	MODE,7		; POWER OFF
	return

;-----------------------------------------------
; `c̓͂ 0XB0 ȏo
;-----------------------------------------------
MODE3
; IF ADRESH < 0xB0 THEN return
	movlw	0xB0
	subwf	ADRESH,W
	btfss	STATUS,C
	goto	MODE4

	bsf	MODE,3
	return

;-----------------------------------------------
; `c̓͂ 0XA0 ȏo
;-----------------------------------------------
MODE4
; IF ADRESH < 0xA0 THEN return
	movlw	0xA0
	subwf	ADRESH,W
	btfss	STATUS,C
	return

	bsf	MODE,4
	return

;==========================================================
; LED@Px
;==========================================================
BRIGHT_CONTROL

;-----------------------------------------------
; FLASH MODE JUNCTION
;-----------------------------------------------
FLASH_MODE0
	btfss	MODE,0
	goto	FLASH_MODE1

	;X^[gAbv@f[^@Xɖ邭ȂB
	movfw	LOOP1
	call	BRIGHT0	
	movwf	CCPR1L		; SET Duty

	return

FLASH_MODE1
	btfss	MODE,1
	goto	FLASH_MODE2

	movfw	LOOP1
	call	BRIGHT2
	movwf	CCPR1L		; SET Duty

	return
FLASH_MODE2
	btfss	MODE,2
	goto	FLASH_MODE3

	movfw	LOOP1
	call	BRIGHT3
	movwf	CCPR1L		; SET Duty

	return

FLASH_MODE3
	btfss	MODE,3
	goto	FLASH_MODE4

	call	RAND
	movfw	RAND_WORK
	call	BRIGHT1

	movwf	RAND_WORK		
	movlw	0X30
	subwf	RAND_WORK,W

	movwf	CCPR1L		; SET Duty
	return

FLASH_MODE4
	btfss	MODE,4
	goto	FLASH_MODE7

	movfw	LOOP1
	call	BRIGHT2
	movwf	CCPR1L		; SET Duty

	return

; 
FLASH_MODE7
	btfss	MODE,7
	goto	NORMAL

	movlw	B'00000001'	; TIMER2 Prescale = 1:4
	movwf	T2CON		; TIMER2 STOP

	clrf 	GPIO

	movlw	0x00		; SET PWM
	movwf	CCP1CON

	call	WAIT100MS

	sleep

	call	WAIT100MS

	movlw	0x0C		; SET PWM
	movwf	CCP1CON

	movlw	B'00000101'	; TIMER2 Prescale = 1:4
	movwf	T2CON		; TIMER2 START

	clrf	MODE
	bsf	MODE,0		; SET STARTUP MODE

	clrf	TMR1_L

	movlw	0xFF
	movwf	ON_TIME1

	movlw	0x0D
	movwf	ON_TIME2

	return
;-----------------------------------------------
; ɂA펞̓_p^[
;-----------------------------------------------
NORMAL				
	call	RAND
	movfw	RAND_WORK
	call	BRIGHT1

	movwf	RAND_WORK

	movlw	0x00		; JE^[̃rbgɂmCY
	btfsc	TMR1_L,0	; TMR1_L̃rbgOPꍇPx0x10
	movlw	0x10		; mCY̑B@px@P^Q
	addwf	RAND_WORK,F

	movlw	0x00		; `c̃rbgɂmCY
	btfsc	ADRESH,2	; `^c̃rbgQPꍇPx0x10
	movlw	0x10		; mCY̑B@px@P^Q`P^S
	subwf	RAND_WORK,W

	movwf	CCPR1L		; SET Duty
	return

;==========================================================
; 
;==========================================================
RAND
	movfw	RAND_VAL_L
	movwf	RAND_TMP_L
	movfw	RAND_VAL_H
	movwf	RAND_TMP_H

;----------------------------------
; RAND ~ R
; Q{āAP񑫂ƂłR{ƂB
;----------------------------------
	bcf	STATUS,C
	rlf	RAND_VAL_L,F
	rlf	RAND_VAL_H,F	; RAND = RAND * 2

	movfw	RAND_VAL_L
	addwf	RAND_TMP_L,F
	movfw	RAND_VAL_H
	btfsc	STATUS,C
	incf	RAND_VAL_H,W
	addwf	RAND_TMP_H,F	; RAND_TMP = RAND_VAL + RAND_TMP
;----------------------------------
; RAND + 0x79
;----------------------------------
	movlw	0x79
	addwf	RAND_TMP_L,F
	btfsc	STATUS,C
	incf	RAND_TMP_H,F	; RAND_TMP = RAND_TMP + 0x79
;----------------------------------
; ʁAʂ̓ւ
;----------------------------------
	movfw	RAND_TMP_L
	movwf	RAND_VAL_H

	movfw	RAND_TMP_H 
	movwf	RAND_VAL_L 

;----------------------------------
;  0x3F͈̔͂Ɏ߂B
;----------------------------------
	bcf	STATUS,C
	rrf	RAND_VAL_L,F	;

	bcf	STATUS,C
	rrf	RAND_VAL_L,F	;

	movfw	RAND_VAL_L
	movwf	RAND_WORK

	return
;=====================================================================
; WAIT
;=====================================================================
WAIT100MS	
	call	WAIT20MS
	call	WAIT20MS
	call	WAIT20MS
	call	WAIT20MS
	call	WAIT20MS
	return

;---------------------------------------
; WAIT 20mS
;---------------------------------------
WAIT20MS	
	movlw	D'200'		; 20mS WAIT
	movwf	WAIT2

WAIT20MS_LOOP
	movlw	D'65'		; 0.1mS WAIT
	movwf	WAIT1

	decfsz	WAIT1,F
	goto	$-1

         	decfsz	WAIT2,F
         	goto	WAIT20MS_LOOP
         	return
;---------------------------------------
; WAIT 5mS
;---------------------------------------
WAIT5MS	
	movlw	D'50'	  	; 5mS WAIT
	movwf	WAIT2

WAIT5MS_LOOP
	movlw	D'65'		; 0.1mS WAIT
	movwf	WAIT1

	decfsz	WAIT1,F
	goto	$-1

         	decfsz	WAIT2,F
         	goto	WAIT5MS_LOOP
         	return
;---------------------------------------
; WAIT 0.1mS
;---------------------------------------
WAIT01MS 
	movlw	D'65'		; 0.1mS WAIT
	movwf	WAIT1

	decfsz	WAIT1,F
	goto	$-1
	return

;---------------------------------------
; 20uS WAIT (CLOCK 8MHZ)
;---------------------------------------
WAIT20US
	movlw	0X0B
	movwf	WAIT2

	decfsz	WAIT2,F
	goto	$-1

	goto	$+1
	return

;=====================================================================
; Pxf[^
;=====================================================================
;-------------------------------------------------------
; uCgf[^
; _Jn
;-------------------------------------------------------
BRIGHT0
	movwf	A_SAVE
	movlw	low(BRIGHT0_)
	addwf	A_SAVE,1
	movlw	high(BRIGHT0_)
	movwf	PCLATH
	addcf	PCLATH,1
	movf	A_SAVE,0
	movwf	PCL
BRIGHT0_
	retlw	0x70		;01
	retlw	0x70		;02
	retlw	0x70		;03
	retlw	0x60		;04
	retlw	0x60		;05
	retlw	0x60		;06
	retlw	0x60		;07
	retlw	0x60		;08
	retlw	0x50		;09
	retlw	0x50		;10
	retlw	0x50		;11
	retlw	0x50		;12
	retlw	0x50		;13
	retlw	0x40		;14
	retlw	0x40		;15
	retlw	0x40		;16
	retlw	0x40		;17
	retlw	0x40		;18
	retlw	0x30		;19
	retlw	0x30		;20
	retlw	0x30		;21
	retlw	0x30		;22
	retlw	0x30		;23
	retlw	0x30		;24
	retlw	0x20		;25
	retlw	0x20		;26
	retlw	0x20		;27
	retlw	0x20		;28
	retlw	0x20		;29
	retlw	0x20		;30
	retlw	0x20		;31
	retlw	0x10		;32
	retlw	0x10		;33
	retlw	0x10		;34
	retlw	0x10		;35
	retlw	0x10		;36
	retlw	0x10		;37
	retlw	0x08		;38
	retlw	0x08		;39
	retlw	0x08		;40
	retlw	0x08		;41
	retlw	0x08		;42
	retlw	0x06		;43
	retlw	0x06		;44
	retlw	0x06		;45
	retlw	0x06		;46
	retlw	0x06		;47
	retlw	0x04		;48
	retlw	0x04		;49
	retlw	0x04		;50
	retlw	0x04		;51
	retlw	0x02		;52
	retlw	0x02		;53
	retlw	0x02		;54
	retlw	0x02		;55
	retlw	0x02		;56
	retlw	0x01		;57
	retlw	0x01		;58
	retlw	0x01		;59
	retlw	0x01		;60
	retlw	0x01		;61
	retlw	0x01		;62
	retlw	0x01		;63
	retlw	0x00		;64

;-------------------------------------------------------
; uCgf[^
; O
;-------------------------------------------------------
BRIGHT1
	movwf	A_SAVE
	movlw	low(BRIGHT1_)
	addwf	A_SAVE,1
	movlw	high(BRIGHT1_)
	movwf	PCLATH
	addcf	PCLATH,1
	movf	A_SAVE,0
	movwf	PCL
BRIGHT1_
	retlw	0x50		;01	
	retlw	0x50		;02
	retlw	0x51		;03
	retlw	0x52		;04
	retlw	0x52		;05
	retlw	0x53		;06
	retlw	0x54		;07
	retlw	0x55		;08
	retlw	0x55		;09
	retlw	0x55		;10
	retlw	0x57		;11
	retlw	0x58		;12
	retlw	0x58		;13
	retlw	0x59		;14
	retlw	0x5B		;15
	retlw	0x5C		;16
	retlw	0x5C		;17
	retlw	0x5D		;18
	retlw	0x5D		;19
	retlw	0x5E		;20
	retlw	0x5F		;21
	retlw	0x5F		;22
	retlw	0x60		;23
	retlw	0x60		;24
	retlw	0x60		;25
	retlw	0x60		;26
	retlw	0x60		;27
	retlw	0x61		;28
	retlw	0x61		;29
	retlw	0x61		;30
	retlw	0x61		;31
	retlw	0x61		;32
	retlw	0x61		;33
	retlw	0x62		;34
	retlw	0x63		;35
	retlw	0x63		;36
	retlw	0x64		;37
	retlw	0x66		;38
	retlw	0x67		;39
	retlw	0x67		;40
	retlw	0x68		;41
	retlw	0x69		;42
	retlw	0x69		;43
	retlw	0x69		;44
	retlw	0x6A		;45
	retlw	0x6B		;46
	retlw	0x6B		;47
	retlw	0x6B		;48
	retlw	0x6C		;49
	retlw	0x6C		;50
	retlw	0x6C		;51
	retlw	0x6C		;52
	retlw	0x6D		;53
	retlw	0x6D		;54
	retlw	0x6D		;55
	retlw	0x6D		;56
	retlw	0x6E		;57
	retlw	0x6E		;58
	retlw	0x6E		;59
	retlw	0x6E		;60
	retlw	0x6F		;61
	retlw	0x6F		;62
	retlw	0x6F		;63
	retlw	0x6F		;64
                  
;-------------------------------------------------------
; uCgf[^
; O
;-------------------------------------------------------
BRIGHT2
		movwf	A_SAVE
		movlw	low(BRIGHT2_)
		addwf	A_SAVE,1
		movlw	high(BRIGHT2_)
		movwf	PCLATH
		addcf	PCLATH,1
		movf	A_SAVE,0
		movwf	PCL
BRIGHT2_
	retlw	0x60		;01
	retlw	0x60		;02
	retlw	0x70		;03
	retlw	0x70		;04
	retlw	0x80		;05
	retlw	0x80		;06
	retlw	0x90		;07
	retlw	0x90		;08
	retlw	0xB0		;09
	retlw	0xB0		;10
	retlw	0xC0		;11
	retlw	0xC0		;12
	retlw	0xB0		;13
	retlw	0xB0		;14
	retlw	0x70		;15
	retlw	0x70		;16
	retlw	0x80		;17
	retlw	0x80		;18
	retlw	0xA0		;19
	retlw	0xA0		;20
	retlw	0xB0		;21
	retlw	0xB0		;22
	retlw	0xB0		;23
	retlw	0xB0		;24
	retlw	0xC0		;25
	retlw	0xC0		;26
	retlw	0xB0		;27
	retlw	0xB0		;28
	retlw	0xB0		;29
	retlw	0x90		;30
	retlw	0x70		;31
	retlw	0x70		;32
	retlw	0x80		;33
	retlw	0x80		;34
	retlw	0x90		;35
	retlw	0x90		;36
	retlw	0xB0		;37
	retlw	0xB0		;38
	retlw	0xC0		;39
	retlw	0xC0		;40
	retlw	0xD0		;41
	retlw	0xD0		;42
	retlw	0xC0		;43
	retlw	0xC0		;44
	retlw	0xA0		;45
	retlw	0xA0		;46
	retlw	0x90		;47
	retlw	0x90		;48
	retlw	0xB0		;49
	retlw	0xB0		;50
	retlw	0xC0		;51
	retlw	0xC0		;52
	retlw	0xB0		;53
	retlw	0xB0		;54
	retlw	0xA0		;55
	retlw	0xA0		;56
	retlw	0x90		;57
	retlw	0x90		;58
	retlw	0x80		;59
	retlw	0x80		;60
	retlw	0x70		;61
	retlw	0x70		;62
	retlw	0x70		;63
	retlw	0x70		;64

;-------------------------------------------------------
; uCgf[^
; Oア
;-------------------------------------------------------
BRIGHT3
	movwf	A_SAVE
	movlw	low(BRIGHT3_)
	addwf	A_SAVE,1
	movlw	high(BRIGHT3_)
	movwf	PCLATH
	addcf	PCLATH,1
	movf	A_SAVE,0
	movwf	PCL
BRIGHT3_
	retlw	0x70		;01
	retlw	0x70		;02
	retlw	0x70		;03
	retlw	0x80		;04
	retlw	0x80		;05
	retlw	0x80		;06
	retlw	0x80		;07
	retlw	0x90		;08
	retlw	0xA0		;09
	retlw	0x90		;10
	retlw	0xA0		;11
	retlw	0x90		;12
	retlw	0xA0		;13
	retlw	0xB0		;14
	retlw	0xA0		;15
	retlw	0xB0		;16
	retlw	0xA0		;17
	retlw	0xB0		;18
	retlw	0xC0		;19
	retlw	0xD0		;20
	retlw	0xD0		;21
	retlw	0xC0		;22
	retlw	0xD0		;23
	retlw	0xD0		;24
	retlw	0xD0		;25
	retlw	0xD0		;26
	retlw	0xC0		;27
	retlw	0xC0		;28
	retlw	0xC0		;29
	retlw	0xC0		;30
	retlw	0xD0		;31
	retlw	0xD0		;32
	retlw	0xE0		;33
	retlw	0xE0		;34
	retlw	0xD0		;35
	retlw	0xD0		;36
	retlw	0xD0		;37
	retlw	0xD0		;38
	retlw	0xC0		;39
	retlw	0xC0		;40
	retlw	0xC0		;41
	retlw	0xB0		;42
	retlw	0xD0		;43
	retlw	0xB0		;44
	retlw	0xB0		;45
	retlw	0xB0		;46
	retlw	0xC0		;47
	retlw	0xC0		;48
	retlw	0xC0		;49
	retlw	0xA0		;50
	retlw	0xA0		;51
	retlw	0xA0		;52
	retlw	0xA0		;53
	retlw	0x90		;54
	retlw	0x90		;55
	retlw	0x90		;56
	retlw	0x80		;57
	retlw	0x80		;58
	retlw	0x80		;59
	retlw	0x80		;60
	retlw	0x70		;61
	retlw	0x70		;62
	retlw	0x70		;63
	retlw	0x70		;64

	END
